Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.type
Class BuiltInAtomicType

    java.lang.Object
      net.sf.saxon.type.BuiltInAtomicType

All Implemented Interfaces:
  java.io.Serializable, AtomicType, ItemType, SchemaComponent, SchemaType, SimpleType

    public class BuiltInAtomicType

extends java.lang.Object
implements AtomicType, java.io.Serializable

This class represents a built-in atomic type, which may be either a primitive type (such as xs:decimal or xs:anyURI) or a derived type (such as xs:ID or xs:dayTimeDuration).

See Also:
  Serialized Form

Field Summary
`static BuiltInAtomicType` | `ANY_ATOMIC`
`static BuiltInAtomicType` | `ANY_URI`
`static BuiltInAtomicType` | `BASE64_BINARY`
`static BuiltInAtomicType` | `BOOLEAN`
`static BuiltInAtomicType` | `BYTE`
`static BuiltInAtomicType` | `DATE`
`static BuiltInAtomicType` | `DATE_TIME`
`static BuiltInAtomicType` | `DAY_TIME_DURATION`
`static BuiltInAtomicType` | `DECIMAL`
`static BuiltInAtomicType` | `DOUBLE`
`static BuiltInAtomicType` | `DURATION`
`static BuiltInAtomicType` | `ENTITY`
`static BuiltInAtomicType` | `FLOAT`
`static BuiltInAtomicType` | `G_DAY`
`static BuiltInAtomicType` | `G_MONTH`
`static BuiltInAtomicType` | `G_MONTH_DAY`
`static BuiltInAtomicType` | `G_YEAR`
`static BuiltInAtomicType` | `G_YEAR_MONTH`
`static BuiltInAtomicType` | `HEX_BINARY`
`static BuiltInAtomicType` | `ID`
`static BuiltInAtomicType` | `IDREF`
`static BuiltInAtomicType` | `INT`
`static BuiltInAtomicType` | `INTEGER`
`static BuiltInAtomicType` | `LANGUAGE`
`static BuiltInAtomicType` | `LONG`
`static BuiltInAtomicType` | `NAME`
`static BuiltInAtomicType` | `NCNAME`
`static BuiltInAtomicType` | `NEGATIVE_INTEGER`
`static BuiltInAtomicType` | `NMTOKEN`
`static BuiltInAtomicType` | `NON_NEGATIVE_INTEGER`
`static BuiltInAtomicType` | `NON_POSITIVE_INTEGER`
`static BuiltInAtomicType` | `NORMALIZED_STRING`
`static BuiltInAtomicType` | `NOTATION`
`static BuiltInAtomicType` | `NUMERIC`
`static BuiltInAtomicType` | `POSITIVE_INTEGER`
`static BuiltInAtomicType` | `QNAME`
`static BuiltInAtomicType` | `SHORT`
`static BuiltInAtomicType` | `STRING`
`static BuiltInAtomicType` | `TIME`
`static BuiltInAtomicType` | `TOKEN`
`static BuiltInAtomicType` | `UNSIGNED_BYTE`
`static BuiltInAtomicType` | `UNSIGNED_INT`
`static BuiltInAtomicType` | `UNSIGNED_LONG`
`static BuiltInAtomicType` | `UNSIGNED_SHORT`
`static BuiltInAtomicType` | `UNTYPED_ATOMIC`
`static BuiltInAtomicType` | `YEAR_MONTH_DURATION`

Fields inherited from interface net.sf.saxon.type.SchemaType
`DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

Fields inherited from interface net.sf.saxon.type.SchemaComponent
`FIXED_UP, INCOMPLETE, INVALID, UNVALIDATED, VALIDATED, VALIDATING`

Method Summary
`boolean` | `allowsDerivation(int derivation)` Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
`void` | `analyzeContentExpression(Expression expression, int kind, StaticContext env)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
`static void` | `analyzeContentExpression(SimpleType simpleType, Expression expression, StaticContext env, int kind)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
`Value` | `atomize(NodeInfo node)` Get the typed value of a node that is annotated with this schema type.
`void` | `checkTypeDerivationIsOK(SchemaType type, int block)` Check that this type is validly derived from a given type
`boolean` | `equals(java.lang.Object obj)` Two types are equal if they have the same fingerprint.
`AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized
`SchemaType` | `getBaseType()` Returns the base type that this type inherits from.
`int` | `getBlock()` Returns the value of the 'block' attribute for this type, as a bit-significant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
`SchemaType` | `getBuiltInBaseType()` Returns the built-in base type this type is derived from.
`AtomicType` | `getCommonAtomicType()` Get the most specific possible atomic type that all items in this SimpleType belong to
`int` | `getDerivationMethod()` Gets the integer code of the derivation method used to derive this type from its parent.
`java.lang.String` | `getDescription()` Get a description of this type for use in error messages.
`java.lang.String` | `getDisplayName()` Get the display name of the type: that is, a lexical QName with an arbitrary prefix
`int` | `getFingerprint()` Get the fingerprint of the name of this type
`SchemaType` | `getKnownBaseType()` Returns the base type that this type inherits from.
`java.lang.String` | `getName()` Get the local name of this type
`int` | `getNameCode()` Get the namecode of the name of this type.
`ItemType` | `getPrimitiveItemType()` Get the primitive item type corresponding to this item type.
`int` | `getPrimitiveType()` Get the primitive type corresponding to this item type.
`StructuredQName` | `getQualifiedName()` Get the name of the type as a QName
`ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
`java.lang.String` | `getSystemId()` Get the URI of the schema document where the type was originally defined.
`java.lang.String` | `getTargetNamespace()` Get the target namespace of this type
`SequenceIterator` | `getTypedValue(java.lang.CharSequence value, NamespaceResolver resolver, NameChecker nameChecker)` Get the typed value corresponding to a given string value, assuming it is valid against this type (and that the containing node is not nilled)
`SequenceIterator` | `getTypedValue(NodeInfo node)` Get the typed value of a node that is annotated with this schema type
`int` | `getValidationStatus()` Get the validation status - always valid
`int` | `getWhitespaceAction(TypeHierarchy th)` Determine the whitespace normalization required for values of this type
`int` | `hashCode()` The fingerprint can be used as a hashcode
`boolean` | `isAbstract()` Determine whether the type is abstract, that is, whether it cannot have instances that are not also instances of some concrete subtype
`boolean` | `isAllowedInBasicXSLT()` Determine whether this type is supported in a basic XSLT processor
`boolean` | `isAnonymousType()` Test whether this is an anonymous type
`boolean` | `isAtomicType()` Test whether this Simple Type is an atomic type
`boolean` | `isBuiltInType()` Determine whether this is a built-in type or a user-defined type
`boolean` | `isComplexType()` Test whether this SchemaType is a complex type
`boolean` | `isExternalType()` Return true if this is an external object type, that is, a Saxon-defined type for external Java or .NET objects
`boolean` | `isListType()` Returns true if this type is derived by list, or if it is derived by restriction from a list type, or if it is a union that contains a list as one of its members
`boolean` | `isNamespaceSensitive()` Test whether this simple type is namespace-sensitive, that is, whether it is derived from xs:QName or xs:NOTATION
`boolean` | `isOrdered()` Determine whether the atomic type is ordered, that is, whether less-than and greater-than comparisons are permitted
`boolean` | `isPrimitiveNumeric()` Determine whether the atomic type is numeric
`boolean` | `isPrimitiveType()` Determine whether the atomic type is a primitive type.
`boolean` | `isSameType(SchemaType other)` Test whether this is the same type as another type.
`boolean` | `isSimpleType()` Returns true if this SchemaType is a SimpleType
`boolean` | `isUnionType()` Return true if this type is a union type (that is, if its variety is union)
`boolean` | `matchesItem(Item item, boolean allowURIPromotion, Configuration config)` Test whether a given item conforms to this type
`void` | `setBaseTypeFingerprint(int baseFingerprint)` Set the base type of this type
`java.lang.String` | `toString()`
`java.lang.String` | `toString(NamePool pool)` Produce a representation of this type name for use in error messages.
`ValidationFailure` | `validate(AtomicValue primValue, java.lang.CharSequence lexicalValue, NameChecker checker)` Validate that a primitive atomic value is a valid instance of a type derived from the same primitive type.
`ValidationFailure` | `validateContent(java.lang.CharSequence value, NamespaceResolver nsResolver, NameChecker nameChecker)` Check whether a given input string is valid according to this SimpleType

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### ANY_ATOMIC

    public static BuiltInAtomicType ANY_ATOMIC

### NUMERIC

    public static BuiltInAtomicType NUMERIC

### STRING

    public static BuiltInAtomicType STRING

### BOOLEAN

    public static BuiltInAtomicType BOOLEAN

### DURATION

    public static BuiltInAtomicType DURATION

### DATE_TIME

    public static BuiltInAtomicType DATE_TIME

### DATE

    public static BuiltInAtomicType DATE

### TIME

    public static BuiltInAtomicType TIME

### G_YEAR_MONTH

    public static BuiltInAtomicType G_YEAR_MONTH

### G_MONTH

    public static BuiltInAtomicType G_MONTH

### G_MONTH_DAY

    public static BuiltInAtomicType G_MONTH_DAY

### G_YEAR

    public static BuiltInAtomicType G_YEAR

### G_DAY

    public static BuiltInAtomicType G_DAY

### HEX_BINARY

    public static BuiltInAtomicType HEX_BINARY

### BASE64_BINARY

    public static BuiltInAtomicType BASE64_BINARY

### ANY_URI

    public static BuiltInAtomicType ANY_URI

### QNAME

    public static BuiltInAtomicType QNAME

### NOTATION

    public static BuiltInAtomicType NOTATION

### UNTYPED_ATOMIC

    public static BuiltInAtomicType UNTYPED_ATOMIC

### DECIMAL

    public static BuiltInAtomicType DECIMAL

### FLOAT

    public static BuiltInAtomicType FLOAT

### DOUBLE

    public static BuiltInAtomicType DOUBLE

### INTEGER

    public static BuiltInAtomicType INTEGER

### NON_POSITIVE_INTEGER

    public static BuiltInAtomicType NON_POSITIVE_INTEGER

### NEGATIVE_INTEGER

    public static BuiltInAtomicType NEGATIVE_INTEGER

### LONG

    public static BuiltInAtomicType LONG

### INT

    public static BuiltInAtomicType INT

### SHORT

    public static BuiltInAtomicType SHORT

### BYTE

    public static BuiltInAtomicType BYTE

### NON_NEGATIVE_INTEGER

    public static BuiltInAtomicType NON_NEGATIVE_INTEGER

### POSITIVE_INTEGER

    public static BuiltInAtomicType POSITIVE_INTEGER

### UNSIGNED_LONG

    public static BuiltInAtomicType UNSIGNED_LONG

### UNSIGNED_INT

    public static BuiltInAtomicType UNSIGNED_INT

### UNSIGNED_SHORT

    public static BuiltInAtomicType UNSIGNED_SHORT

### UNSIGNED_BYTE

    public static BuiltInAtomicType UNSIGNED_BYTE

### YEAR_MONTH_DURATION

    public static BuiltInAtomicType YEAR_MONTH_DURATION

### DAY_TIME_DURATION

    public static BuiltInAtomicType DAY_TIME_DURATION

### NORMALIZED_STRING

    public static BuiltInAtomicType NORMALIZED_STRING

### TOKEN

    public static BuiltInAtomicType TOKEN

### LANGUAGE

    public static BuiltInAtomicType LANGUAGE

### NAME

    public static BuiltInAtomicType NAME

### NMTOKEN

    public static BuiltInAtomicType NMTOKEN

### NCNAME

    public static BuiltInAtomicType NCNAME

### ID

    public static BuiltInAtomicType ID

### IDREF

    public static BuiltInAtomicType IDREF

### ENTITY

    public static BuiltInAtomicType ENTITY

Method Detail

### getName

    public java.lang.String getName()

  Get the local name of this type

  Specified by:
    `getName` in interface `SchemaType`
  Returns:
    the local name of this type definition, if it has one. Return null in the case of an anonymous type.

### getTargetNamespace

    public java.lang.String getTargetNamespace()

  Get the target namespace of this type

  Specified by:
    `getTargetNamespace` in interface `SchemaType`
  Returns:
    the target namespace of this type definition, if it has one. Return null in the case of an anonymous type, and in the case of a global type defined in a no-namespace schema.

### isAbstract

    public boolean isAbstract()

  Determine whether the type is abstract, that is, whether it cannot have instances that are not also instances of some concrete subtype

  Specified by:
    `isAbstract` in interface `AtomicType`

### isExternalType

    public boolean isExternalType()

  Return true if this is an external object type, that is, a Saxon-defined type for external Java or .NET objects

  Specified by:
    `isExternalType` in interface `SimpleType`
  Returns:
    true if this is an external type

### isBuiltInType

    public boolean isBuiltInType()

  Determine whether this is a built-in type or a user-defined type

  Specified by:
    `isBuiltInType` in interface `AtomicType`
  Specified by:
    `isBuiltInType` in interface `SimpleType`
  Returns:
    true if this is a built-in type

### isOrdered

    public boolean isOrdered()

  Determine whether the atomic type is ordered, that is, whether less-than and greater-than comparisons are permitted

  Specified by:
    `isOrdered` in interface `AtomicType`
  Returns:
    true if ordering operations are permitted

### getSystemId

    public java.lang.String getSystemId()

  Get the URI of the schema document where the type was originally defined.

  Specified by:
    `getSystemId` in interface `SchemaType`
  Returns:
    the URI of the schema document. Returns null if the information is unknown or if this is a built-in type

### isPrimitiveNumeric

    public boolean isPrimitiveNumeric()

  Determine whether the atomic type is numeric

  Returns:
    true if the type is a built-in numeric type

### getCommonAtomicType

    public AtomicType getCommonAtomicType()

  Get the most specific possible atomic type that all items in this SimpleType belong to

  Specified by:
    `getCommonAtomicType` in interface `SimpleType`
  Returns:
    the lowest common supertype of all member types

### getValidationStatus

    public final int getValidationStatus()

  Get the validation status - always valid

  Specified by:
    `getValidationStatus` in interface `SchemaComponent`
  Returns:
    one of the values `SchemaComponent.UNVALIDATED`, `SchemaComponent.VALIDATING`, `SchemaComponent.VALIDATED`, `SchemaComponent.INVALID`, `SchemaComponent.INCOMPLETE`

### getBlock

    public final int getBlock()

  Returns the value of the 'block' attribute for this type, as a bit-significant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`

  Specified by:
    `getBlock` in interface `SchemaType`
  Returns:
    the value of the 'block' attribute for this type

### getDerivationMethod

    public final int getDerivationMethod()

  Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.

  Specified by:
    `getDerivationMethod` in interface `SchemaType`
  Returns:
    a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

### allowsDerivation

    public final boolean allowsDerivation(int derivation)

  Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property

  Specified by:
    `allowsDerivation` in interface `SchemaType`
  Parameters:
    `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
  Returns:
    true if this kind of derivation is allowed

### setBaseTypeFingerprint

    public final void setBaseTypeFingerprint(int baseFingerprint)

  Set the base type of this type

  Parameters:
    `baseFingerprint` - the namepool fingerprint of the name of the base type

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the name of this type

  Specified by:
    `getFingerprint` in interface `SchemaType`
  Returns:
    the fingerprint. Returns an invented fingerprint for an anonymous type.

### getNameCode

    public int getNameCode()

  Get the namecode of the name of this type. This includes the prefix from the original type declaration: in the case of built-in types, there may be a conventional prefix or there may be no prefix.

  Specified by:
    `getNameCode` in interface `SchemaType`
  Returns:
    the namecode. Returns an invented namecode for an anonymous type.

### getQualifiedName

    public StructuredQName getQualifiedName()

  Get the name of the type as a QName

  Returns:
    a StructuredQName containing the name of the type. The conventional prefix "xs" is used to represent the XML Schema namespace

### getDisplayName

    public java.lang.String getDisplayName()

  Get the display name of the type: that is, a lexical QName with an arbitrary prefix

  Specified by:
    `getDisplayName` in interface `SchemaType`
  Returns:
    a lexical QName identifying the type

### isPrimitiveType

    public boolean isPrimitiveType()

  Determine whether the atomic type is a primitive type. The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration; xs:untypedAtomic; and all supertypes of these (xs:anyAtomicType, xs:numeric, ...)

  Specified by:
    `isPrimitiveType` in interface `AtomicType`
  Returns:
    true if the type is considered primitive under the above rules

### isComplexType

    public final boolean isComplexType()

  Test whether this SchemaType is a complex type

  Specified by:
    `isComplexType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a complex type

### isAnonymousType

    public boolean isAnonymousType()

  Test whether this is an anonymous type

  Specified by:
    `isAnonymousType` in interface `SchemaType`
  Returns:
    true if this SchemaType is an anonymous type

### getBaseType

    public final SchemaType getBaseType()

  Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid. If this type is a Simpletype that is a built in primitive type then null is returned.

  Specified by:
    `getBaseType` in interface `SchemaType`
  Returns:
    the base type.
  Throws:
    `java.lang.IllegalStateException` - if this type is not valid.

### matchesItem

    public boolean matchesItem(Item item,
                               boolean allowURIPromotion,
                               Configuration config)

  Test whether a given item conforms to this type

  Specified by:
    `matchesItem` in interface `ItemType`
  Parameters:
    `item` - The item to be tested
    `allowURIPromotion` - true if we regard a URI as effectively a subtype of String
    `config` - the Saxon configuration (used to locate the type hierarchy cache)
  Returns:
    true if the item is an instance of this type; false otherwise

### getSuperType

    public ItemType getSuperType(TypeHierarchy th)

  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xs:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  Specified by:
    `getSuperType` in interface `ItemType`
  Parameters:
    `th` - the type hierarchy cache, not used in this implementation
  Returns:
    the supertype, or null if this type is item()

### getPrimitiveItemType

    public ItemType getPrimitiveItemType()

  Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

  Specified by:
    `getPrimitiveItemType` in interface `ItemType`

### getPrimitiveType

    public int getPrimitiveType()

  Get the primitive type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

  Specified by:
    `getPrimitiveType` in interface `ItemType`

### isAllowedInBasicXSLT

    public boolean isAllowedInBasicXSLT()

  Determine whether this type is supported in a basic XSLT processor

  Returns:
    true if this type is permitted in a basic XSLT processor

### toString

    public java.lang.String toString(NamePool pool)

  Produce a representation of this type name for use in error messages. Where this is a QName, it will use conventional prefixes

  Specified by:
    `toString` in interface `ItemType`

### getAtomizedItemType

    public AtomicType getAtomizedItemType()

  Get the item type of the atomic values that will be produced when an item of this type is atomized

  Specified by:
    `getAtomizedItemType` in interface `ItemType`

### getKnownBaseType

    public SchemaType getKnownBaseType()

  Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid. If this type is a Simpletype that is a built in primitive type then null is returned.

  Returns:
    the base type.
  Throws:
    `java.lang.IllegalStateException` - if this type is not valid.

### isSameType

    public boolean isSameType(SchemaType other)

  Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)

  Specified by:
    `isSameType` in interface `SchemaType`
  Parameters:
    `other` - the other type
  Returns:
    true if this is the same type as other

### getDescription

    public java.lang.String getDescription()

  Description copied from interface: `SchemaType`
  Get a description of this type for use in error messages. This is the same as the display name in the case of named types; for anonymous types it identifies the type by its position in a source schema document.

  Specified by:
    `getDescription` in interface `SchemaType`
  Returns:
    text identifing the type, for use in a phrase such as "the type XXXX".

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### checkTypeDerivationIsOK

    public void checkTypeDerivationIsOK(SchemaType type,
                                        int block)
                                 throws SchemaException

  Check that this type is validly derived from a given type

  Specified by:
    `checkTypeDerivationIsOK` in interface `SchemaType`
  Parameters:
    `type` - the type from which this type is derived
    `block` - the derivations that are blocked by the relevant element declaration
  Throws:
    `SchemaException` - if the derivation is not allowed

### isSimpleType

    public final boolean isSimpleType()

  Returns true if this SchemaType is a SimpleType

  Specified by:
    `isSimpleType` in interface `SchemaType`
  Returns:
    true (always)

### isAtomicType

    public boolean isAtomicType()

  Test whether this Simple Type is an atomic type

  Specified by:
    `isAtomicType` in interface `ItemType`
  Specified by:
    `isAtomicType` in interface `SchemaType`
  Specified by:
    `isAtomicType` in interface `SimpleType`
  Returns:
    true, this is an atomic type

### isListType

    public boolean isListType()

  Returns true if this type is derived by list, or if it is derived by restriction from a list type, or if it is a union that contains a list as one of its members

  Specified by:
    `isListType` in interface `SimpleType`
  Returns:
    true if this is a list type

### isUnionType

    public boolean isUnionType()

  Return true if this type is a union type (that is, if its variety is union)

  Specified by:
    `isUnionType` in interface `SimpleType`
  Returns:
    true for a union type

### getWhitespaceAction

    public int getWhitespaceAction(TypeHierarchy th)

  Determine the whitespace normalization required for values of this type

  Specified by:
    `getWhitespaceAction` in interface `SimpleType`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    one of PRESERVE, REPLACE, COLLAPSE

### getBuiltInBaseType

    public SchemaType getBuiltInBaseType()

  Returns the built-in base type this type is derived from.

  Specified by:
    `getBuiltInBaseType` in interface `SimpleType`
  Returns:
    the first built-in type found when searching up the type hierarchy

### isNamespaceSensitive

    public boolean isNamespaceSensitive()

  Test whether this simple type is namespace-sensitive, that is, whether it is derived from xs:QName or xs:NOTATION

  Specified by:
    `isNamespaceSensitive` in interface `SimpleType`
  Returns:
    true if this type is derived from xs:QName or xs:NOTATION

### validateContent

    public ValidationFailure validateContent(java.lang.CharSequence value,
                                             NamespaceResolver nsResolver,
                                             NameChecker nameChecker)

  Check whether a given input string is valid according to this SimpleType

  Specified by:
    `validateContent` in interface `SimpleType`
  Parameters:
    `value` - the input string to be checked
    `nsResolver` - a namespace resolver used to resolve namespace prefixes if the type is namespace sensitive. The value supplied may be null; in this case any namespace-sensitive content will throw an UnsupportedOperationException.
    `nameChecker` - XML 1.0 or 1.1 name checker. Must not be null.
  Returns:
    XPathException if the value is invalid. Note that the exception is returned rather than being thrown. Returns null if the value is valid.
  Throws:
    `java.lang.UnsupportedOperationException` - if the type is namespace-sensitive and no namespace resolver is supplied

### getTypedValue

    public final SequenceIterator getTypedValue(NodeInfo node)
                                         throws XPathException

  Get the typed value of a node that is annotated with this schema type

  Specified by:
    `getTypedValue` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    an iterator over the items making up the typed value of this node. The objects returned by this SequenceIterator will all be of type `AtomicValue`
  Throws:
    `XPathException`

### atomize

    public Value atomize(NodeInfo node)
                  throws XPathException

  Get the typed value of a node that is annotated with this schema type. The result of this method will always be consistent with the method `getTypedValue(net.sf.saxon.om.NodeInfo)`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    the typed value.
  Throws:
    `XPathException`
  Since:
    8.5

### getTypedValue

    public SequenceIterator getTypedValue(java.lang.CharSequence value,
                                          NamespaceResolver resolver,
                                          NameChecker nameChecker)
                                   throws ValidationException

  Get the typed value corresponding to a given string value, assuming it is valid against this type (and that the containing node is not nilled)

  Specified by:
    `getTypedValue` in interface `SimpleType`
  Parameters:
    `value` - the string value
    `resolver` - a namespace resolver used to resolve any namespace prefixes appearing in the content of values. Can supply null, in which case any namespace-sensitive content will be rejected.
    `nameChecker` - XML 1.0 or 1.1 name checker. May be null if name checking is not required
  Returns:
    an iterator over the atomic sequence comprising the typed value. The objects returned by this SequenceIterator will all be of type `AtomicValue`
  Throws:
    `ValidationException` - if the supplied value is not in the lexical space of the data type

### equals

    public boolean equals(java.lang.Object obj)

  Two types are equal if they have the same fingerprint. Note: it is normally safe to use ==, because we always use the static constants, one instance for each built in atomic type. However, after serialization and deserialization a different instance can appear.

  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  The fingerprint can be used as a hashcode

  Overrides:
    `hashCode` in class `java.lang.Object`

### validate

    public ValidationFailure validate(AtomicValue primValue,
                                      java.lang.CharSequence lexicalValue,
                                      NameChecker checker)

  Validate that a primitive atomic value is a valid instance of a type derived from the same primitive type.

  Specified by:
    `validate` in interface `AtomicType`
  Parameters:
    `primValue` - the value in the value space of the primitive type.
    `lexicalValue` - the value in the lexical space. If null, the string value of primValue is used. This value is checked against the pattern facet (if any)
    `checker` - Used to check names against XML 1.0 or XML 1.1 syntax rules
  Returns:
    null if the value is valid; otherwise, a ValidationFailure object indicating the nature of the error.
  Throws:
    `java.lang.UnsupportedOperationException` - in the case of an external object type

### analyzeContentExpression

    public void analyzeContentExpression(Expression expression,
                                         int kind,
                                         StaticContext env)
                                  throws XPathException

  Analyze an expression to see whether the expression is capable of delivering a value of this type.

  Specified by:
    `analyzeContentExpression` in interface `SchemaType`
  Parameters:
    `expression` - the expression that delivers the content
    `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
    `env` - the static context
  Throws:
    `XPathException` - if the expression will never deliver a value of the correct type

### analyzeContentExpression

    public static void analyzeContentExpression(SimpleType simpleType,
                                                Expression expression,
                                                StaticContext env,
                                                int kind)
                                         throws XPathException

  Analyze an expression to see whether the expression is capable of delivering a value of this type.

  Parameters:
    `simpleType` - the simple type against which the expression is to be checked
    `expression` - the expression that delivers the content
    `env` - the static context of the expression
    `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
  Throws:
    `XPathException` - if the expression will never deliver a value of the correct type

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) Saxonica Limited. All rights reserved.